/* routine to merge together two text files, for the mergeIndices.c
 * project ... 871205-... ^z -- mods 871230 for XFCN -- ^z
 *
 * Since the 6 big buffers have all been released by now, there is enough
 * room in memory for a buffer of size 6*zbufsiz ... so use that here....
 * and release it when finished!
 */

#include "mergeIndices.z.h"

extern Str255 fn[3][3];
extern int vRef[3][3], refNum[3][3];
extern long zbufsiz;

int merge_text_files ()
  {
	char *buf;
	long count;
	int err;
	
	give_msg ("\pMerging dataspace text files... please be patient!");
	if ((buf = NewPtr (6 * zbufsiz)) == NULL)
	  {
		give_msg ("\pError allocating merge buffer! -- click mouse to exit...");
		beepWait ();
		return (0);
	  }
	if (SetFPos (refNum[SECONDIN][TEXTFILE], fsFromStart, 0L) != noErr)
	  {
		give_msg ("\pError setting up to merge second text file! -- click mouse to exit...");
		DisposPtr (buf);
		beepWait ();
		return (0);
	  }
	if (SetFPos (refNum[FIRSTIN][TEXTFILE], fsFromLEOF, 0L) != noErr)
	  {
		give_msg ("\pError setting up to merge first text file! -- click mouse to exit...");
		DisposPtr (buf);
		beepWait ();
		return (0);
	  }
	for (;;)
	  {
		count = 6 * zbufsiz;
		err = FSRead (refNum[SECONDIN][TEXTFILE], &count, buf);
		if (err != noErr && err != eofErr)
		  {
			give_msg ("\pRead error while merging text files! -- click mouse to exit...");
			DisposPtr (buf);
			beepWait ();
			return (0);
		  }
		if (count == 0)
			break;
		if (FSWrite (refNum[FIRSTIN][TEXTFILE], &count, buf) != noErr)
		  {
			give_msg ("\pWrite error while merging text files! -- click mouse to exit...");
			DisposPtr (buf);
			beepWait ();
			return (0);
		  }
	  }
	give_msg ("\pText files successfully merged!");
	DisposPtr (buf);
	return (1);
  }

